## ucommon 7.0.0

=== CMakeLists.txt ===
# Copyright (C) 2009-2014 David Sugar, Tycho Softworks
# Copyright (C) 2015 Cherokees of Idaho.
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# This is a simplified build system for GNU uCommon.  In particular, it
# offers limited cmodel linkage support, at least for mingw32 support (and
# probably visual c 6 also).  If one really needs to do such things outside
# these use cases, it is suggested to continue using the existing autotools
# configure script driven build environment instead.  Mostly the cmake one is
# meant for generating project files for those working with IDE's to do
# otherwise generic builds of the library and supporting applications.

cmake_minimum_required(VERSION 2.6)
PROJECT(ucommon)
set (VERSION 7.0.0)

if(BIICODE)
    include(dyfet/ucommon/cmake/biicode)
    return()
endif()

# when we override default install prefix, assume full path is used...

if(WIN32)
    set(MODULE_FLAGS "-module -shared -no-undefined")
else()
    set(MODULE_FLAGS "-module -shared -avoid-version")
endif()

# project options

option(BUILD_STDLIB "Set to OFF to disable C++ stdlib" ON)
if(WIN32)
    option(BUILD_RUNTIME "Set to OFF to build static runtime" ON)
    if(BUILD_RUNTIME)
        set(BUILD_RUNTIME_TYPE SHARED)
    endif()
    option(BUILD_STATIC "Set to OFF to build shared libraries" ON)
    set(POSIX_TIMERS OFF CACHE BOOL "does not use posix timers" FORCE)
else()
    option(BUILD_STATIC "Set to ON to build static libraries" OFF)
    option(POSIX_TIMERS "Set to ON to enable" OFF)
endif()

option(BUILD_EXTRAS  "Set to OFF to disable" ON)
option(BUILD_TESTING "Set to ON to build test programs" OFF)
option(CRYPTO_STATIC "Set to ON to build static crypto" OFF)
option(CRYPTO_OPENSSL "Set to OFF to disable openssl" ON)

MARK_AS_ADVANCED(POSIX_TIMERS BUILD_EXTRAS)

MESSAGE( STATUS "Configuring GNU ${PROJECT_NAME} ${VERSION}...")
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckIncludeFiles)
include(CTest)
include(CapeConfig)
include(CapeMakeTargets)
include(ucommon)
include(config)

# we are making this optional in automake, not default...

find_package(PkgConfig)

if(HAVE_REGEX_H)
    check_library_exists(regex regfree "" HAVE_REGEX_LIB)
    if(HAVE_REGEX_LIB OR MINGW OR MSYS)
        set(UCOMMON_LIBS ${UCOMMON_LIBS} "regex")
    endif()
endif()

set(UCOMMON_LIBS ${UCOMMON_LIBS} ${UCOMMON_LINKING})

# for some reason, normal library searches always fail on broken windows
if (WIN32 AND NOT UNIX AND NOT MINGW AND NOT MSYS)
    set(HAVE_GETADDRINFO True)
    set(HAVE_INET_NTOP True)
endif()

# alternate we use generic cmake openssl search...
if(CRYPTO_OPENSSL AND PKGCONFIG_FOUND)
    pkg_check_modules(OPENSSL openssl>=1.0.0)
endif()
if(CRYPTO_OPENSSL AND NOT OPENSSL_FOUND)
    FIND_PACKAGE(OpenSSL)
    if(OPENSSL_FOUND)
        set(OPENSSL_INCLUDE_DIRS "${OPENSSL_INCLUDE_DIR}")
        set(CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES};${OPENSSL_INCLUDE_DIR}")
    endif()
endif()
if(OPENSSL_FOUND)
    set(HAVE_OPENSSL TRUE)
    check_include_files(openssl/fips.h HAVE_OPENSSL_FIPS_H)
elseif(PKGCONFIG_FOUND)
    pkg_check_modules(GNUTLS gnutls>=3.0.0)
endif()

# common build options can be passed to cmake using WITH_CFLAGS, WITH_LIBS,
# and WITH_INCLUDES.
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc ${WITH_INCLUDES})
add_definitions(${UCOMMON_FLAGS} ${WITH_CFLAGS})
link_libraries(${WITH_LIBS})

# by default we build static libs for windows, shared libs for unix.
# we may also set this from a top level cmake or -DWITH_XX_LIBS

if(BUILD_STATIC)
    set(BUILD_LIBRARY_TYPE STATIC)
    set(BUILD_CRYPTO_TYPE STATIC)
else()
    set(BUILD_LIBRARY_TYPE SHARED)
    if(CRYPTO_STATIC)
        set(BUILD_CRYPTO_TYPE STATIC)
    else()
        set(BUILD_CRYPTO_TYPE SHARED)
    endif()
endif()

if(NOT BUILD_RUNTIME_TYPE)
    set(BUILD_RUNTIME_TYPE ${BUILD_LIBRARY_TYPE})
endif()

file(GLOB common_src corelib/*.cpp)
file(GLOB ucommon_inc inc/ucommon/*.h)
file(GLOB commoncpp_src commoncpp/*.cpp)
file(GLOB commoncpp_inc inc/commoncpp/*.h)
file(GLOB scripts_man *.1)
file(GLOB cmakes_inc cmake/Cape*.cmake)
list(REMOVE_ITEM ucommon_inc inc/ucommon/secure.h)
set(secure_inc inc/ucommon/secure.h)

if(OPENSSL_FOUND)
    include_directories(${OPENSSL_INCLUDE_DIRS})
    link_directories(${OPENSSL_LIBRARY_DIRS})
    file(GLOB secure_src openssl/*.cpp openssl/*.h)
    list(APPEND secure_src nossl/common.cpp)
    if(MINGW)
        set(SECURE_LIBS ${OPENSSL_LIBRARIES} gdi32 z)
    elseif(WIN32 AND NOT CYGWIN)
        set(SECURE_LIBS ${OPENSSL_LIBRARIES} gdi32)
    else()
        set(SECURE_LIBS ${OPENSSL_LIBRARIES})
    endif()
elseif(GNUTLS_FOUND)
    include_directories(${GNUTLS_INCLUDE_DIRS})
    link_directories(${GNUTLS_LIBRARY_DIRS})
    file(GLOB secure_src gnutls/*.cpp gnutls/*.h)
    list(APPEND secure_src nossl/common.cpp)
    set(SECURE_LIBS ${GNUTLS_LIBRARIES})
else()
    file(GLOB secure_src nossl/*.cpp nossl/*.h)
endif()

pc_flags(PKG_UCOMMON_FLAGS ${UCOMMON_FLAGS} ${UCOMMON_VISIBILITY_FLAG})
pc_libs(PKG_UCOMMON_LIBS ${UCOMMON_LIBS})
pc_libs(PKG_SECURE_LIBS ${SECURE_LIBS})

create_specfile()
create_headers(ucommon-config.h)
create_scripts(scripts_cfg ucommon-config commoncpp-config)
create_scripts(localscripts PKGBUILD)
create_pcfiles(pc_files ucommon commoncpp)

add_library(ucommon ${BUILD_RUNTIME_TYPE} ${common_src} ${ucommon_inc})
set_library_version(ucommon)
target_link_libraries(ucommon ${UCOMMON_LIBS} ${WITH_LIBS})

add_library(usecure ${BUILD_CRYPTO_TYPE} ${secure_src} ${secure_inc})
set_library_version(usecure)
target_link_libraries(usecure ucommon ${WITH_LIBS} ${SECURE_LIBS} ${UCOMMON_LIBS})
add_dependencies(usecure ucommon)

if(BUILD_STDLIB)
    add_library(commoncpp ${BUILD_LIBRARY_TYPE} ${commoncpp_src} ${commoncpp_inc})
    set_library_version(commoncpp)
    target_link_libraries(commoncpp ucommon ${UCOMMON_LIBS} ${WITH_LIBS} ${SECURE_LIBS})
    add_dependencies(commoncpp ucommon)
endif()

if (BUILD_EXTRAS)
    add_subdirectory(utils)
endif()

if (BUILD_TESTING)
    ENABLE_TESTING()
    add_subdirectory(test)
endif()

install(FILES ${pc_files} DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
install(FILES ${scripts_cfg} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${scripts_man} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install(FILES ${cmakes_inc} DESTINATION ${CMAKE_INSTALL_DATADIR}/ucommon/cmake)
install(FILES ${ucommon_inc} ${secure_inc} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ucommon)
install(FILES ${commoncpp_inc} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/commoncpp)

if(BUILD_STDLIB)
    install(TARGETS commoncpp DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

install(TARGETS ucommon usecure DESTINATION ${CMAKE_INSTALL_LIBDIR})

# cmake std targets not used; dist made on automake...
#add_cape_make_targets(ucommon ${VERSION})
add_make_lint_target()
add_cape_docs_target(Doxyfile)
add_make_uninstall_target()

=== test/CMakeLists.txt ===
# Copyright (C) 2009-2014 David Sugar, Tycho Softworks.
# Copyright (C) 2015 Cherokees of Idaho.
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

project(test)
cmake_minimum_required(VERSION 2.6)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/../inc)

link_directories(${CMAKE_CURRENT_BINARY_DIR})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/keydata.conf ${CMAKE_CURRENT_BINARY_DIR}/keydata.conf COPYONLY)

add_executable(test-ucommonLinked linked.cpp)
target_link_libraries(test-ucommonLinked ucommon)
add_test(NAME ucommonLinked COMMAND test-ucommonLinked)

add_executable(test-ucommonSocket socket.cpp)
target_link_libraries(test-ucommonSocket ucommon)
add_test(NAME ucommonSocket COMMAND test-ucommonSocket)

add_executable(test-ucommonStrings string.cpp)
target_link_libraries(test-ucommonStrings ucommon)
add_test(NAME ucommonStrings COMMAND test-ucommonStrings)

add_executable(test-ucommonThreads thread.cpp)
target_link_libraries(test-ucommonThreads ucommon)
add_test(NAME ucommonThreads COMMAND test-ucommonThreads)

add_executable(test-ucommonKeydata keydata.cpp)
target_link_libraries(test-ucommonKeydata ucommon)
add_test(NAME ucommonKeydata COMMAND test-ucommonKeydata)

add_executable(test-ucommonMemory memory.cpp)
target_link_libraries(test-ucommonMemory ucommon)
add_test(NAME ucommonMemory COMMAND test-ucommonMemory)

add_executable(test-ucommonStream stream.cpp)
target_link_libraries(test-ucommonStream ucommon)
add_test(NAME ucommonStream COMMAND test-ucommonStream)

add_executable(test-ucommonUnicode unicode.cpp)
target_link_libraries(test-ucommonUnicode ucommon)
add_test(NAME ucommonUnicode COMMAND test-ucommonUnicode)

add_executable(test-ucommonDatetime datetime.cpp)
target_link_libraries(test-ucommonDatetime ucommon)
add_test(NAME ucommonDatetime COMMAND test-ucommonDatetime)

add_executable(test-ucommonShell shell.cpp)
target_link_libraries(test-ucommonShell ucommon)
add_test(NAME ucommonShell COMMAND test-ucommonShell)

add_executable(test-ucommonCipher cipher.cpp)
target_link_libraries(test-ucommonCipher usecure ucommon)
add_test(NAME ucommonCipher COMMAND test-ucommonCipher)
add_dependencies(test-ucommonCipher usecure ucommon)

add_executable(test-ucommonDigest digest.cpp)
target_link_libraries(test-ucommonDigest usecure ucommon)
add_test(NAME ucommonDigest COMMAND test-ucommonDigest)
add_dependencies(test-ucommonDigest usecure ucommon)

=== utils/CMakeLists.txt ===
# Copyright (C) 2009-2014 David Sugar, Tycho Softworks
# Copyright (C) 2015 Cherokees of Idaho.
#
# This file is free software; as a special exception the author gives
# unlimited permission to copy and/or distribute it, with or without
# modifications, as long as this notice is preserved.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY, to the extent permitted by law; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# This is a simplified build system for GNU uCommon.  In particular, it
# offers limited cmodel linkage support, at least for mingw32 support (and
# probably visual c 6 also).  If one really needs to do such things outside
# these use cases, it is suggested to continue using the existing autotools
# configure script driven build environment instead.  Mostly the cmake one is
# meant for generating project files for those working with IDE's to do
# otherwise generic builds of the library and supporting applications.

file(GLOB ucommon_man *.1)

add_executable(ucommon-args args.cpp)
add_dependencies(ucommon-args ucommon)
set_target_properties(ucommon-args PROPERTIES OUTPUT_NAME args)
target_link_libraries(ucommon-args ucommon ${UCOMMON_LIBS} ${WITH_LIBS})

add_executable(usecure-car car.cpp)
add_dependencies(usecure-car usecure ucommon)
set_target_properties(usecure-car PROPERTIES OUTPUT_NAME car)
target_link_libraries(usecure-car usecure ucommon ${SECURE_LIBS} ${UCOMMON_LIBS} ${WITH_LIBS})

add_executable(ucommon-keywait keywait.cpp)
add_dependencies(ucommon-keywait ucommon)
set_target_properties(ucommon-keywait PROPERTIES OUTPUT_NAME keywait)
target_link_libraries(ucommon-keywait ucommon ${UCOMMON_LIBS} ${WITH_LIBS})

add_executable(ucommon-pdetach pdetach.cpp)
add_dependencies(ucommon-pdetach ucommon)
set_target_properties(ucommon-pdetach PROPERTIES OUTPUT_NAME pdetach)
target_link_libraries(ucommon-pdetach ucommon ${UCOMMON_LIBS} ${WITH_LIBS})

add_executable(ucommon-sockaddr sockaddr.cpp)
add_dependencies(ucommon-sockaddr ucommon)
set_target_properties(ucommon-sockaddr PROPERTIES OUTPUT_NAME sockaddr)
target_link_libraries(ucommon-sockaddr ucommon ${UCOMMON_LIBS} ${WITH_LIBS})

add_executable(usecure-scrub scrub.cpp)
add_dependencies(usecure-scrub usecure ucommon)
set_target_properties(usecure-scrub PROPERTIES OUTPUT_NAME scrub-files)
target_link_libraries(usecure-scrub usecure ucommon ${SECURE_LIBS} ${UCOMMON_LIBS} ${WITH_LIBS})

add_executable(usecure-mdsum mdsum.cpp)
add_dependencies(usecure-mdsum usecure ucommon)
set_target_properties(usecure-mdsum PROPERTIES OUTPUT_NAME mdsum)
target_link_libraries(usecure-mdsum usecure ucommon ${SECURE_LIBS} ${UCOMMON_LIBS} ${WITH_LIBS})

add_executable(usecure-urlout urlout.cpp)
add_dependencies(usecure-urlout usecure ucommon)
set_target_properties(usecure-urlout PROPERTIES OUTPUT_NAME urlout)
target_link_libraries(usecure-urlout usecure ucommon ${SECURE_LIBS} ${UCOMMON_LIBS} ${WITH_LIBS})

add_executable(usecure-zerofill zerofill.cpp)
add_dependencies(usecure-zerofill usecure ucommon)
set_target_properties(usecure-zerofill PROPERTIES OUTPUT_NAME zerofill)
target_link_libraries(usecure-zerofill usecure ucommon ${SECURE_LIBS} ${UCOMMON_LIBS} ${WITH_LIBS})

install(TARGETS ucommon-args ucommon-pdetach ucommon-keywait usecure-car usecure-scrub usecure-mdsum ucommon-sockaddr usecure-urlout usecure-zerofill DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${ucommon_man} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== debian/changelog ===
ucommon (7.0.0-19) unstable; urgency=medium

  * Team Upload
  * Fix yet another optional symbol
  * Drop -dbgsym migration from before oldstable

 -- Bernhard Schmidt <berni@debian.org>  Tue, 08 Dec 2020 22:46:41 +0100

ucommon (7.0.0-18) unstable; urgency=medium

  * Team Upload
  * Mark new symbol optional (missing on arm*) (Closes: #976824)
  * Update d/watch

 -- Bernhard Schmidt <berni@debian.org>  Tue, 08 Dec 2020 20:29:03 +0100

ucommon (7.0.0-17) unstable; urgency=medium

  * Team Upload
  * Use C++ filter for new symbol

  [ Bastian Germann ]
  * Add missing symbol (Closes: #957895)

  [ Matthias Klose ]
  * Mark one more symbol optional, not present when built with -O3
    (Closes: #923639)

 -- Bernhard Schmidt <berni@debian.org>  Mon, 07 Dec 2020 14:17:32 +0100

ucommon (7.0.0-16) unstable; urgency=medium

  * Team Upload
  * Mark one symbol as optional, fix FTBFS on some architectures

 -- Bernhard Schmidt <berni@debian.org>  Wed, 19 Dec 2018 23:33:47 +0100

ucommon (7.0.0-15) unstable; urgency=medium

  * Team Upload
  * Add missing symbols for newer toolchain (Closes: #913397)

 -- Bernhard Schmidt <berni@debian.org>  Wed, 19 Dec 2018 22:23:54 +0100

ucommon (7.0.0-14) unstable; urgency=medium

  * Team Upload

  [ Adrian Bunk ]
  * Fix FTBFS on some arches due to a missing symbol (Closes: #897878)

 -- Bernhard Schmidt <berni@debian.org>  Mon, 13 Aug 2018 22:47:44 +0200

ucommon (7.0.0-13) unstable; urgency=medium

  * Team Upload

  [ Adrian Bunk ]
  * Fix symbols for gcc 8. (Closes: #897878)
  * Fix symbols for ia64 and riscv64. (Closes: #898502)

  [ Bernhard Schmidt ]
  * Update Vcs-* to salsa

 -- Bernhard Schmidt <berni@debian.org>  Sun, 12 Aug 2018 23:54:01 +0200

ucommon (7.0.0-12) unstable; urgency=medium

  * Add copyright-check maintainer script to source.
    Revive and update copyright_hints.
  * Update copyright info:
    + Drop superfluous copyright signs.
    + Use SPDX License shortname FSFULLR (and derived forms).
    + Drop superfluous disclaimers.
    + Extend coverage for myself.
  * Tighten lintian overrides regarding License-Reference.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 08 Sep 2017 11:21:56 +0200

ucommon (7.0.0-11) unstable; urgency=medium

  * Remove symbols missing with GCC 7

 -- Peter Colberg <peter@colberg.org>  Sun, 20 Aug 2017 11:18:07 -0400

ucommon (7.0.0-10) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * Update upstream source URLs.
  * Have git-buildpackage config filter any .git* file.
  * Drop Bug field from DEP3 header of patch 1001.
    Apparently upstream didn't preserve old issues when moving Github account.

  [ Peter Colberg ]
  * Update symbols for GCC 7 (Closes: #853691)
  * Use https for copyright-format URL
  * Update Standards-Version to 4.0.0

 -- Peter Colberg <peter@colberg.org>  Sat, 19 Aug 2017 11:23:43 -0400

ucommon (7.0.0-9) unstable; urgency=medium

  * Avoid compilation of libraries and tests for arch-independent builds

 -- Peter Colberg <peter@colberg.org>  Sat, 29 Oct 2016 08:08:53 -0400

ucommon (7.0.0-8) unstable; urgency=medium

  * Fix missing symbols on powerpcspe
  * Fix missing symbols on sh4

 -- Peter Colberg <peter@colberg.org>  Fri, 28 Oct 2016 22:20:14 -0400

ucommon (7.0.0-7) unstable; urgency=medium

  * Upload to unstable (Closes: #831211)
  * Fix mismatching symbols on kfreebsd-i386

 -- Peter Colberg <peter@colberg.org>  Wed, 26 Oct 2016 22:14:12 -0400

ucommon (7.0.0-7~exp4) experimental; urgency=medium

  * Use arch-bits symbol tag instead of non-standard subst tag
  * Restore arch-specific symbols for variadic functions
  * Fix mismatching symbols on x32
  * Fix mismatching symbols on hurd-i386
  * Build with all hardening flags
  * Link with -Wl,--as-needed to avoid useless library dependencies
  * Always fail in case of mismatching symbols

 -- Peter Colberg <peter@colberg.org>  Tue, 25 Oct 2016 23:06:24 -0400

ucommon (7.0.0-7~exp3) experimental; urgency=medium

  * Switch from CDBS to dh
  * Build depend on graphviz for arch-independent builds only
  * Add dependency on libjs-jquery to ucommon-doc
  * Bump debhelper compat level to 10
  * Replace -dbg package with automatic -dbgsym package
  * Build with bindnow hardening flag
  * Substitute arch-dependent size_t in symbols file
  * Exclude useless autogenerated doxygen files
  * Register HTML documentation with doc-base
  * Fix spelling mistakes found by lintian
  * Use /git/ instead of /cgit/ in Vcs-Browser field
  * Add myself to Uploaders

 -- Peter Colberg <peter@colberg.org>  Sat, 22 Oct 2016 23:22:27 -0400

ucommon (7.0.0-7~exp2) experimental; urgency=medium

  * Temporarily stop build-depend on licensecheck.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 13 Sep 2016 22:39:44 +0200

ucommon (7.0.0-7~exp1) experimental; urgency=medium

  * Relax symbols check when targeting experimental.
  * Have CDBS resolve Debian suite.
    Stop build-depend on recent dpkg-dev.
  * Modernize CDBS: Build-depend on license-check (not devscripts).
  * De-mangle, sort, and deduplicate symbols.
  * Reset arch and subst symbol tags (apparently g++6 transition
    confuses pkgkde-sysmbolshelper).

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 13 Sep 2016 19:37:24 +0200

ucommon (7.0.0-6) unstable; urgency=medium

  * Use dh-autoreconf (not cdbs) to regenerate autotools.
    Closes: Bug#826391. Thanks to Chris Lamb.
  * Update package relations:
    + Build-depend on dh-autoreconf.
    + Stop (explicitly) build-depend on libtool automake autoconf.
    + Relax build-dependency on cdbs.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 08 Jun 2016 20:58:45 +0200

ucommon (7.0.0-5) unstable; urgency=medium

  * Update Vcs-* fields: Packaging has moved to Debian VoIP team.
  * Update symbols file.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 21 Apr 2016 10:39:37 +0200

ucommon (7.0.0-4) unstable; urgency=medium

  * Update symbols file.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 14 Apr 2016 10:50:18 +0200

ucommon (7.0.0-3) experimental; urgency=medium



=== debian/control ===
Source: ucommon
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Jonas Smedegaard <dr@jones.dk>, Peter Colberg <peter@colberg.org>
Build-Depends: debhelper (>= 10),
               dpkg-dev (>= 1.18.0~),
               libgnutls28-dev,
               pkg-config
Build-Depends-Indep: doxygen-latex, graphviz
Standards-Version: 4.0.0
Section: net
Homepage: http://www.gnu.org/software/commoncpp/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/ucommon.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/ucommon

Package: libucommon-dev
Section: libdevel
Architecture: any
Depends: libgnutls28-dev, libucommon8 (= ${binary:Version}), ${misc:Depends}
Recommends: pkg-config
Suggests: ucommon-doc
Description: lightweight C++ threading and sockets - development files
 GNU uCommon C++ is a lightweight library to facilitate using C++ design
 patterns even for very deeply embedded applications, such as for
 systems using uClibc along with POSIX threading support. For this
 reason, uCommon disables language features that consume memory or
 introduce runtime overhead. uCommon introduces some design patterns
 from Objective-C, such as reference counted objects, memory pools, and
 smart pointers.  uCommon introduces some new concepts for handling of
 thread locking and synchronization.
 .
 This package contains the development headers and static libraries.

Package: libucommon8
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: ucommon-utils
Conflicts: libucommon7
Replaces: libucommon7
Description: lightweight C++ threading and sockets - shared libraries
 GNU uCommon C++ is a lightweight library to facilitate using C++ design
 patterns even for very deeply embedded applications, such as for
 systems using uClibc along with POSIX threading support. For this
 reason, uCommon disables language features that consume memory or
 introduce runtime overhead. uCommon introduces some design patterns
 from Objective-C, such as reference counted objects, memory pools, and
 smart pointers.  uCommon introduces some new concepts for handling of
 thread locking and synchronization.
 .
 This package contains the shared libraries.

Package: ucommon-utils
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: lightweight C++ threading and sockets - utilities
 GNU uCommon C++ is a lightweight library to facilitate using C++ design
 patterns even for very deeply embedded applications, such as for
 systems using uClibc along with POSIX threading support. For this
 reason, uCommon disables language features that consume memory or
 introduce runtime overhead. uCommon introduces some design patterns
 from Objective-C, such as reference counted objects, memory pools, and
 smart pointers.  uCommon introduces some new concepts for handling of
 thread locking and synchronization.
 .
 This package contains the following utilities included as part of the
 GNU uCommon C++ project:
  * args
  * car
  * keywait
  * mdsum
  * scrub
  * sockaddr
  * zerofill

Package: ucommon-doc
Section: doc
Architecture: all
Depends: libjs-jquery, ${misc:Depends}
Description: lightweight C++ threading and sockets - documentation
 GNU uCommon C++ is a lightweight library to facilitate using C++ design
 patterns even for very deeply embedded applications, such as for
 systems using uClibc along with POSIX threading support. For this
 reason, uCommon disables language features that consume memory or
 introduce runtime overhead. uCommon introduces some design patterns
 from Objective-C, such as reference counted objects, memory pools, and
 smart pointers.  uCommon introduces some new concepts for handling of
 thread locking and synchronization.
 .
 This package contains the API documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Avoid useless library dependencies
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
# Always fail in case of mismatching symbols
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4

%:
	dh $@

# Strip bad pkg-config directives
override_dh_auto_configure:
	dh_auto_configure
	perl -i -pe 's/\s+-[fW]\S+//g' *.pc

override_dh_auto_build-indep:
	$(MAKE) doxy

override_dh_auto_test-indep:

override_dh_auto_install-indep:

override_dh_installdocs:
	dh_installdocs --exclude=.map --exclude=.md5

=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
https://mirrors.kernel.org/gnu/commoncpp/ \
 @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ debian

## ucommon 7.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Copyright (C) 2009-2014 David Sugar, Tycho Softworks
-# Copyright (C) 2015 Cherokees of Idaho.
+# Copyright (C) 2015-2020 Cherokees of Idaho.
 #
 # This file is free software; as a special exception the author gives
 # unlimited permission to copy and/or distribute it, with or without
@@ -17,14 +17,10 @@
 # meant for generating project files for those working with IDE's to do
 # otherwise generic builds of the library and supporting applications.
 
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 3.12)
 PROJECT(ucommon)
-set (VERSION 7.0.0)
-
-if(BIICODE)
-    include(dyfet/ucommon/cmake/biicode)
-    return()
-endif()
+set (VERSION 7.0.1)
+set (CMAKE_MACOSX_RPATH 1)
 
 # when we override default install prefix, assume full path is used...
 
@@ -68,6 +64,19 @@
 include(CapeMakeTargets)
 include(ucommon)
 include(config)
+
+# some platform detection support, especially for bsd's...
+
+if(NOT DEFINED CMAKE_TOOLCHAIN_FILE)
+    if(EXISTS "/usr/local/lib/")
+        include_directories("/usr/local/include")
+        link_directories("/usr/local/lib")
+    endif()
+    if(EXISTS "/usr/pkg/lib/")
+        include_directories("/usr/pkg/include")
+        link_directories("/usr/pkg/lib")
+    endif()
+endif()
 
 # we are making this optional in automake, not default...
 
@@ -169,7 +178,6 @@
 create_specfile()
 create_headers(ucommon-config.h)
 create_scripts(scripts_cfg ucommon-config commoncpp-config)
-create_scripts(localscripts PKGBUILD)
 create_pcfiles(pc_files ucommon commoncpp)
 
 add_library(ucommon ${BUILD_RUNTIME_TYPE} ${common_src} ${ucommon_inc})
@@ -210,8 +218,16 @@
 
 install(TARGETS ucommon usecure DESTINATION ${CMAKE_INSTALL_LIBDIR})
 
-# cmake std targets not used; dist made on automake...
-#add_cape_make_targets(ucommon ${VERSION})
-add_make_lint_target()
+# Common tarball distribution
+if(EXISTS ".git/")
+    add_custom_target(dist
+        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
+        COMMAND "${CMAKE_COMMAND}" -E remove -F "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-*.tar.gz"
+        COMMAND git archive -o "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-${VERSION}.tar.gz" --format tar.gz --prefix="${PROJECT_NAME}-${VERSION}/" "v${VERSION}" 2>/dev/null || git archive -o "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-${VERSION}.tar.gz" --format tar.gz --prefix="${PROJECT_NAME}-${VERSION}/" HEAD
+    )
+endif()
+
+add_cape_make_targets(ucommon ${VERSION})
+#add_make_lint_target()
 add_cape_docs_target(Doxyfile)
-add_make_uninstall_target()
+#add_make_uninstall_target()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Copyright (C) 2009-2014 David Sugar, Tycho Softworks.
-# Copyright (C) 2015 Cherokees of Idaho.
+# Copyright (C) 2015-2020 Cherokees of Idaho.
 #
 # This file is free software; as a special exception the author gives
 # unlimited permission to copy and/or distribute it, with or without
@@ -11,7 +11,7 @@
 #
 
 project(test)
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 3.10)
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}
                     ${CMAKE_CURRENT_SOURCE_DIR}/../inc)

=== utils/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Copyright (C) 2009-2014 David Sugar, Tycho Softworks
-# Copyright (C) 2015 Cherokees of Idaho.
+# Copyright (C) 2015-2020 Cherokees of Idaho.
 #
 # This file is free software; as a special exception the author gives
 # unlimited permission to copy and/or distribute it, with or without

=== debian/changelog ===
ucommon (7.0.1-1) unstable; urgency=medium

  * Team upload
  * Move to debhelper-compat
  * Add missing symbol (Closes: #1115758)
  * pkg-config -> pkgconf
  * Drop unnecessary lintian override

 -- Bastian Germann <bage@debian.org>  Fri, 17 Oct 2025 19:36:24 +0200

ucommon (7.0.1-0.4) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbols file to fix a i386 regression (subst missing support on
    dpkg side (Closes: #1081107, Closes: #1068887)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Sep 2024 15:32:10 +0200

ucommon (7.0.1-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbols for 64-bit time_t

 -- Steve Langasek <vorlon@debian.org>  Mon, 18 Mar 2024 05:22:48 +0000

ucommon (7.0.1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062999

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 19:59:51 +0000

ucommon (7.0.1-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version 7.0.1 (Closes: #984373, #1005770)
  * update copyright info: URLs, years
  * drop all patches (applied upstream)
  * add one optional c++ symbol

 -- Bastian Germann <bage@debian.org>  Sat, 09 Apr 2022 02:13:50 +0200

ucommon (7.0.0-20) unstable; urgency=medium

  * team upload

  [ Jonas Smedegaard ]
  * remove myself as uploader
  * simplify source helper script copyright-check
  * update copyright info:
    + use Reference field (not License-Reference);
      tighten lintian overrides
    + use License-Grant
    + update coverage
  * work around FTPFS with g++ 11 by setting CXXFLAG -std=c++14
    (see bug#984373)

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 10 Nov 2021 18:27:33 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: ucommon
 Priority: optional
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
-Uploaders: Jonas Smedegaard <dr@jones.dk>, Peter Colberg <peter@colberg.org>
-Build-Depends: debhelper (>= 10),
-               dpkg-dev (>= 1.18.0~),
+Uploaders: Peter Colberg <peter@colberg.org>
+Build-Depends: dpkg-dev (>= 1.22.5),
+               debhelper-compat (= 12),
                libgnutls28-dev,
-               pkg-config
+               pkgconf
 Build-Depends-Indep: doxygen-latex, graphviz
 Standards-Version: 4.0.0
 Section: net
@@ -16,8 +16,7 @@
 Package: libucommon-dev
 Section: libdevel
 Architecture: any
-Depends: libgnutls28-dev, libucommon8 (= ${binary:Version}), ${misc:Depends}
-Recommends: pkg-config
+Depends: libgnutls28-dev, libucommon8t64 (= ${binary:Version}), ${misc:Depends}
 Suggests: ucommon-doc
 Description: lightweight C++ threading and sockets - development files
  GNU uCommon C++ is a lightweight library to facilitate using C++ design
@@ -31,14 +30,16 @@
  .
  This package contains the development headers and static libraries.
 
-Package: libucommon8
+Package: libucommon8t64
+Provides: ${t64:Provides}
+Breaks: libucommon8 (<< ${source:Version})
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Suggests: ucommon-utils
 Conflicts: libucommon7
-Replaces: libucommon7
+Replaces: libucommon8, libucommon7
 Description: lightweight C++ threading and sockets - shared libraries
  GNU uCommon C++ is a lightweight library to facilitate using C++ design
  patterns even for very deeply embedded applications, such as for

=== debian/rules ===
--- 
+++ 
@@ -2,10 +2,9 @@
 
 # Enable hardening build flags
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-# Avoid useless library dependencies
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
-# Always fail in case of mismatching symbols
-export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
+
+# TODO: patch code to support C++17 (see bug#984373)
+export DEB_CXXFLAGS_MAINT_APPEND = -std=c++14
 
 %:
 	dh $@
